char scs_APVersion[]  ="1.21a";
int  si_APVersion     = 1211;
char scs_IFVersion[]  ="1.21";
int  si_IFVersion     = 1210;
char scs_f2pIFVersion[]  ="1.00";
int  si_f2pIFVersion     = 1000;

char JSign[]="@(#)JPR V.1.21a by JUD(T.Terata) at 2008/ 7/14";
char systemvarsion[]="1.21c"; /* ߍ݃o[W */
char systemdate[]="2008/ 7/14"; /* ߍݓt */

/**********************************************************************/
/* PMDRCC - P.M.D. reversal compiler at CUI by JUD(T.Terata)          */
/**********************************************************************/
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdlib.h>

#include "../common/pmdrcif.h"
#include "../common/f2pcvif.h"

char *anarg( int , char ** );
void setargvalue( char * );
void startdialog( );
void outmml( T_OPIF * );
void initinit( );
char *f2pconvert( char * , int );
char *v2pconvert( char * , int );
int readdatafile( char * , char * );

T_OPIF t_opif;
T_F2PIF t_f2pif;
int gi_dodialog=DA_OFF;
char *gcp_outfilename=NULL;

/* őPMDf[^TCY16kBytes炢 */
#define DN_MAX_OBJSIZE 65536

#define D_FTYPE_ERR -1
#define D_FTYPE_UK 0
#define D_FTYPE_PMD 1
#define D_FTYPE_OPI 2
#define D_FTYPE_OVI 3
#define D_FTYPE_OZI 4
#define D_FTYPE_PMF 5

#define DN_MAX_EXTNAME 8

/*--------------------------------------------------------------------*/
/* EXECUTE-MAIN */
int main(argc,argv)
	int argc;
	char **argv;
{
	char *cp_ret;
	char cs_inname[1024];
	FILE *fp_in;
	char cs_readbuf[DN_MAX_OBJSIZE];
	int i_ret;
	int i_datasize;
	T_OPIF *t1p_ret;
	HINSTANCE x_dllhandle;
	typedef T_OPIF *(CALLBACK* LPFNDLLFUNC1)(T_OPIF *);
	LPFNDLLFUNC1 x_funchandle;
	LPFNDLLFUNC1 x_funcfmhandle;
	DWORD dw_ret=0;
	LPTSTR lpMsgBuf;
	char *cp_data;

	/*  */
	cp_ret = anarg(argc,argv);

	if( cp_ret == NULL ){
		fprintf(stderr,"\nPMDRCC Ver.%s P.M.D. Reversal Compiler for Win32 by JUD at %s\n\n",systemvarsion,systemdate);
		fprintf(stderr,"USAGE : pmdrc.exe [/options] input-filename\n\n");
		fprintf(stderr,"    /nobarline : ߋ؂肵Ȃ (Default=\Ȃ炷)\n");
		fprintf(stderr,"    /dobarline : ߋ؂K (Default=\Ȃ炷)\n");
		fprintf(stderr,"    /novdump   : elFo͂Ȃ (Default=)\n");
		fprintf(stderr,"    /dotx81z   : swWPyelFo͂\n");
		fprintf(stderr,"    /L<value>  : o̓x (Default=3)\n");
		fprintf(stderr,"                  o͂Ȃ : 5 <- 4 -- 3 -> 2 : o͂\n");
		fprintf(stderr,"    /dodump    : gbN_v[h (o̓x=5ɌŒ)\n");
		fprintf(stderr,"    /dosdump   : X[p[gbN_v[h (o̓x=5ɌŒ)\n");
		fprintf(stderr,"    /dodialog  : Θb[h (/Z,/l,/b )\n");
		fprintf(stderr,"    /noautolen : lR}h ʂȂ (Default=)\n");
		fprintf(stderr,"    /l<value>  : lR}h Öق̉ (_s/Default=16 0:gpȂ)\n");
		fprintf(stderr,"    /b<value>  : ŒZ\ \w(_s/Default=16/32)\n");
		fprintf(stderr,"    /Z<value>  : #Zenlen <value>  (48/96 Default=192)\n");
		fprintf(stderr,"    /B<value>  : ߐN_̎w (Default/0:Auto 1:[L] 2:f[^擪)\n");
		fprintf(stderr,"    /F<value>  : ߐN_̃ItZbgw (Default=0)\n");
		fprintf(stderr,"    /@<file>   : F2PCV.DLLꎞt@Co͐\n");
		fprintf(stderr,"    /.<file>   : MMLt@Co͐ (default=Wo)\n");
		exit(0);
	}

	/* t@C */
	strcpy(cs_inname,cp_ret);
	fprintf(stderr," [JPR] Input file name   : %s\n",cs_inname);

	memset( cs_readbuf , 0x00 , DN_MAX_OBJSIZE );
	i_ret = readdatafile( cs_inname , cs_readbuf );
	switch( i_ret ){
		case D_FTYPE_PMD:
			fprintf(stderr," [JPR] File type is PMD.\n");
			cp_data = cs_readbuf;
			break;
		case D_FTYPE_OPI:
		case D_FTYPE_OVI:
		case D_FTYPE_OZI:
			/* FMP->PMDϊ */
			fprintf(stderr," [JPR] File type is FMP.\n");
			cp_data = f2pconvert( cs_readbuf , i_ret );
			break;
		case D_FTYPE_PMF:
			/* VEDf[^t@C */
			fprintf(stderr," [JPR] File type is VED.\n");
			cp_data = v2pconvert( cs_readbuf , i_ret );
			break;
		case D_FTYPE_UK:
		default:
			fprintf(stderr,"E[JPR] Unknown file type.\n");
			return( -1 );
	}
	t_opif.cp_indata = cp_data;

	/* Θb[h */
	if( gi_dodialog == DA_ON ){
		/* Θb[hł́A/Z /l /b ɂĎ^ */
		startdialog();
	}

	/* DLLN */
	x_dllhandle = LoadLibrary( DS_DLLFILENAME );
	if( x_dllhandle == NULL ){
		/* DLLNł */
		fprintf(stderr,"E[JPR] Could not load %s.\n",DS_DLLFILENAME);
		return( -1 );
	}

	/* ֐AhX擾 */
	x_funchandle = (LPFNDLLFUNC1)GetProcAddress( x_dllhandle , DS_DLLFUNCNAME );
	if( x_funchandle == NULL )
	{
		/* ֐Nł */
		fprintf(stderr,"E[JPR] Could not load %s/%s(). [%d]\n",
			DS_DLLFILENAME,DS_DLLFUNCNAME,dw_ret);
		FreeLibrary( x_dllhandle );
		return( -2 );
	}
	x_funcfmhandle = (LPFNDLLFUNC1)GetProcAddress( x_dllhandle , DS_DLLFMFUNCNAME );
	if( x_funcfmhandle == NULL )
	{
		/* ֐Nł */
		fprintf(stderr,"E[JPR] Could not load %s/%s(). [%d]\n",
			DS_DLLFILENAME,DS_DLLFMFUNCNAME,dw_ret);
		FreeLibrary( x_dllhandle );
		return( -3 );
	}

	fprintf(stderr," [JPR] Start analysis by DLL.\n");

	/* ֐[pmdrc.dll/pmdrc_dllmain()]s */
	t1p_ret = x_funchandle( &t_opif );

	fprintf(stderr," [JPR] End analysis by DLL.\n");

	/* ʉ */
	if( t1p_ret == NULL ){
		/* sG[ */
		if( t1p_ret->i_result > 0 ){
			/* warning xȂ̂łƂ肠\͂ */
			fprintf(stderr,"W[JPR] MML incomplete.\n");
			fprintf(stdout," ; Incomplete reverse-compiling.\n");
			outmml( t1p_ret );
		}else{
			/* SɃG[Ȃ̂ŕ\Ȃ */
			fprintf(stderr,"E[JPR] Error [%d].\n",t1p_ret->i_result);
			FreeLibrary( x_dllhandle );
			exit( t1p_ret->i_result );
		}
	}else{
		/* ʕ\ */
		outmml( t1p_ret );
	}

	fprintf(stderr," [JPR] Succeseed output MML.\n");

	/* ̂܂܃vZX̏IȂ̂Ń̕Kv͂Ȃ̂ */
	/* Tv˂Ă̂ ꉞĂ */
	t1p_ret = x_funcfmhandle( t1p_ret );

	FreeLibrary( x_dllhandle );
	exit(0);
}
/*--------------------------------------------------------------------*/
/*  */
/* VEDPMDϊ[`̃R[ */
char *v2pconvert( char *cp_in , int i_type ){

#define DN_SIZE_DUMMYPMDFILE_VED 8192
#define DN_SIZE_DUMMYPMDHEAD_VED 42
#define DN_SIZE_DUMMYPMDFOOT1_VED 7
#define DN_SIZE_DUMMYPMDFOOT3_VED 2
#define DN_SIZE_UNIT_VEDFMDATA 32
#define DN_SIZE_UNIT_VEDFMBODY 25

typedef	struct	_t_ff2{
	short addrpps;		/* PPSAhX */
	short addrppc;		/* PPCAhX */
	short addrtitle;	/* TitleAhX */
	short addrcomp;		/* ComposerAhX */
	short addrarr;		/* ArrengerAhX */
}T_FF2;
static char cs_pconv[DN_SIZE_DUMMYPMDFILE_VED];
	char cs_dummyhead[DN_SIZE_DUMMYPMDHEAD_VED]={
		0x00, 0x1A, 0x00, 0x1B, 0x00, 0x1C, 0x00, 0x1D,
		0x00, 0x1E, 0x00, 0x1F, 0x00, 0x20, 0x00, 0x21,
		0x00, 0x22, 0x00, 0x23, 0x00, 0x24, 0x00, 0x25,
		0x00, 0x29, 0x00, 0x80, 0x80, 0x80, 0x80, 0x80,
		0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x30, 0x1A,
		0x47, 0xFE };
	char cs_dummyfoot1[DN_SIZE_DUMMYPMDFOOT1_VED]={
		0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00 };
	T_FF2 t_dummyfoot2={
		0, 0, 0, 0, 0};
	char cs_dummyfoot3[DN_SIZE_DUMMYPMDFOOT3_VED]={
		0x00, 0x00 };

	char *cp_cur1;
	char *cp_cur2;
	unsigned char *ucp_cur1;
	unsigned int ui_number;
FILE *fp_io;

	memset( cs_pconv , 0x00 , DN_SIZE_DUMMYPMDFILE_VED );
	memcpy( cs_pconv , cs_dummyhead , DN_SIZE_DUMMYPMDHEAD_VED );
	cp_cur1 = cs_pconv + DN_SIZE_DUMMYPMDHEAD_VED;
	cp_cur2 = cp_in;

	for( ui_number=0 ; ui_number<256 ; ui_number++ ){
		ucp_cur1 = cp_cur1;
		*ucp_cur1 = (unsigned char)ui_number;
		cp_cur1++;
		memcpy( cp_cur1 , cp_cur2 , DN_SIZE_UNIT_VEDFMBODY );
		cp_cur1 += DN_SIZE_UNIT_VEDFMBODY;
		cp_cur2 += DN_SIZE_UNIT_VEDFMDATA;
	}

	memcpy( cp_cur1 , cs_dummyfoot1 , DN_SIZE_DUMMYPMDFOOT1_VED );

	t_dummyfoot2.addrpps = (short)((cp_cur1-cs_pconv) + 2 - 1 + 1);
	t_dummyfoot2.addrppc = t_dummyfoot2.addrpps + 1;
	t_dummyfoot2.addrtitle = t_dummyfoot2.addrppc + 1;
	t_dummyfoot2.addrcomp = t_dummyfoot2.addrtitle + 1;
	t_dummyfoot2.addrarr = t_dummyfoot2.addrcomp + 1;
	cp_cur1 += DN_SIZE_DUMMYPMDFOOT1_VED;
	memcpy( cp_cur1 , &t_dummyfoot2 , sizeof(t_dummyfoot2) );

	cp_cur1 += sizeof(t_dummyfoot2);
	memcpy( cp_cur1 , cs_dummyfoot3 , DN_SIZE_DUMMYPMDFOOT3_VED );

	return( cs_pconv );
}
/*--------------------------------------------------------------------*/
/*  */
/* F2PCV.DLL̃R[ */
char *f2pconvert( char *cp_in , int i_type ){

	HINSTANCE x_dllhandle;
	typedef T_F2PIF *(CALLBACK* LPFNDLLFUNC1)(T_F2PIF *);
	LPFNDLLFUNC1 x_funchandle;
	LPFNDLLFUNC1 x_funcfmhandle;
	DWORD dw_ret=0;
	LPTSTR lpMsgBuf;
	char *cp_ret;
	char cs_debug[1024];

	T_F2PIF *t1p_ret;

	/* DLLN */
	x_dllhandle = LoadLibrary( DS_F2PFILENAME );
	if( x_dllhandle == NULL ){
		/* DLLNł */
		fprintf(stderr,"E[JPR] Could not load %s.\n",DS_F2PFILENAME);
		return( NULL );
	}
	/* ֐AhX擾 */
	x_funchandle = (LPFNDLLFUNC1)GetProcAddress( x_dllhandle , DS_F2PFUNCNAME );
	if( x_funchandle == NULL )
	{
		/* ֐Nł */
		fprintf(stderr,"E[JPR] Could not load %s/%s(). [%d]\n",
			DS_F2PFILENAME,DS_F2PFUNCNAME,dw_ret);
		FreeLibrary( x_dllhandle );
		return( NULL );
	}
	x_funcfmhandle = (LPFNDLLFUNC1)GetProcAddress( x_dllhandle , DS_F2PFMFUNCNAME );
	if( x_funcfmhandle == NULL )
	{
		/* ֐Nł */
		fprintf(stderr,"E[JPR] Could not load %s/%s(). [%d]\n",
			DS_F2PFILENAME,DS_F2PFMFUNCNAME,dw_ret);
		FreeLibrary( x_dllhandle );
		return( NULL );
	}

	t_f2pif.i_iv = si_f2pIFVersion;
	t_f2pif.i_directmes = DA_ON;
	t_f2pif.i_datatype = i_type;
	t_f2pif.cp_indata = cp_in;

	/* FMPPMDϊ */
	fprintf(stderr," [JPR] Start convert FMP->PMD.\n");
	t1p_ret = x_funchandle( &t_f2pif );

	/* ʉ */
	if( t1p_ret == NULL ){
		/* sG[ */
		if( t1p_ret->i_result > 0 ){
			/* warning xȂ̂łƂ肠s͂ */
			fprintf(stderr,"W[JPR] convert FMP->PMD incompleteness.\n");
		}else{
			/* SɃG[Ȃ̂ŕ\Ȃ */
			fprintf(stderr,"E[JPR] Convert error [%d].\n",t1p_ret->i_result);
			FreeLibrary( x_dllhandle );
			exit(-1);
		}
	}

	fprintf(stderr," [JPR] Succeseed convert FMP->PMD.\n");

	cp_ret = malloc( t_f2pif.i_datalen + 1 );
	memcpy( cp_ret , t_f2pif.cp_outdata , t_f2pif.i_datalen );

	t1p_ret = x_funcfmhandle( t1p_ret );
	FreeLibrary( x_dllhandle );

	return( cp_ret );
}
/*--------------------------------------------------------------------*/
/*  */
/* t@C̓ǂݎ gq݂Ȃꍇ͎Iɕt */
/* D揇 MZ M2 M OZI OVI OZI */
/* ԋplF-1:ERROR 0-:擾t@C̎ */
int readdatafile( char *cp_name , char *cp_outarea ){

	char cs_fname[1024];
	char cs_addfname[1024];
	char *cp_rcur;
	int i_type=D_FTYPE_UK;
	int i_count;
	int i_ret;
	FILE *fp_in;
	char css_extname[DN_MAX_EXTNAME][8]={
		".MZ", ".M2", ".M", ".OPI", ".OVI", ".OZI", ".FF", ""
	};
	int is_exttype[DN_MAX_EXTNAME]={
		D_FTYPE_PMD,D_FTYPE_PMD,D_FTYPE_PMD,
		D_FTYPE_OPI,D_FTYPE_OVI,D_FTYPE_OZI,
		D_FTYPE_PMF,D_FTYPE_UK };

	strcpy( cs_fname , cp_name );

	/* r̂߁ASLs^ɂĂ */
	for(cp_rcur=cs_fname;(*cp_rcur)!=0x00;cp_rcur++){
		if( (char)'a' <= *cp_rcur && *cp_rcur <= (char)'z' ){
			*cp_rcur = *cp_rcur - 0x20;
		}
	}

	/* gq̌ */
	cp_rcur = strrchr( cs_fname , '.' );
	if( cp_rcur != NULL ){
		/* gq */
		if( strcmp( cp_rcur , ".M" ) == 0 ){
			i_type = D_FTYPE_PMD;
		}else if( strcmp( cp_rcur , ".M2" ) == 0 ){
			i_type = D_FTYPE_PMD;
		}else if( strcmp( cp_rcur , ".MZ" ) == 0 ){
			i_type = D_FTYPE_PMD;
		}else if( strcmp( cp_rcur , ".OPI" ) == 0 ){
			i_type = D_FTYPE_OPI;
		}else if( strcmp( cp_rcur , ".OVI" ) == 0 ){
			i_type = D_FTYPE_OVI;
		}else if( strcmp( cp_rcur , ".OZI" ) == 0 ){
			i_type = D_FTYPE_OZI;
		}else if( strcmp( cp_rcur , ".FF" ) == 0 ){
			i_type = D_FTYPE_PMF;
		}else {
			/* unknowngqolc`ƂĈ */
			i_type = D_FTYPE_PMD;
		}
	}else{
		/* gqȂ */
		i_type = D_FTYPE_UK;
	}

	/* t@CJ */
	if( i_type == D_FTYPE_UK ){
		/* t@C^CvgqłȂ̂ŏɎ */
		for(i_count=0;i_count<DN_MAX_EXTNAME;i_count++){
			/* gqςȂ玟XƎ */
			strcpy( cs_addfname , cs_fname );
			strcat( cs_addfname , css_extname[i_count] );
			fp_in = fopen( cs_addfname , "rb" );
			if( fp_in != NULL ){
				/* t@C */
				i_type = is_exttype[i_count];
				break;
			}
		}
	}else{
		/* m肵ĂgqŊJ */
		fp_in = fopen( cs_fname , "rb" );
	}

	if( fp_in == NULL ){
		/* t@CȂꍇ */
		fprintf(stderr,"E[JPR] Error input file not found. [%s]\n",cp_name);
		return( -1 );
	}

	i_ret = fread(cp_outarea,1,DN_MAX_OBJSIZE,fp_in);
	if( i_ret >= DN_MAX_OBJSIZE ){
		fprintf(stderr,"E[JPR] File too big.\n");
		exit(-1);
	}else if( i_ret < 0 ){
		fprintf(stderr,"E[JPR] File read error.\n");
		exit(-1);
	}
	fclose( fp_in );

	/* TCỸZbg */
	t_opif.i_datasize = i_ret;

	fprintf(stderr," [JPR] Succeed read file.\n");

	return( i_type );
}
/*--------------------------------------------------------------------*/
/* o */
void outmml( T_OPIF *tp_out ){

	int i_count;
	FILE *fp_out;

	if( gcp_outfilename == NULL ){
		/* o̓t@Cw Ȃ */
		fp_out = stdout;
	}else{
		fp_out = fopen( gcp_outfilename , "w" );
		if( fp_out == NULL ){
			/* t@CI[vs͕Wo͂ɏo */
			fp_out = stdout;
			fprintf(stderr," [JPR] Failed open output-file, output to stdout.\n");
		}else{
			fprintf(stderr," [JPR] Output file name  : %s\n",gcp_outfilename);
		}

	}

	/* o̓obt@`FbN */
	/* i_count=1Ŏn܂̂́Acps_out[0]i䃁bZ[Wj */
	/* łɃA^Cŏo͂Ă邽 */
	for(i_count=1;i_count<DN_MAX_OUTBUFFER;i_count++){
		if( tp_out->cps_out[i_count] != NULL ){
			/* o͕񂠂 */
			fprintf(fp_out,"%s",tp_out->cps_out[i_count]);
		}
	}

	/* t@C̃N[Y͕Wo͈ȊOɏo͂Ƃ */
	if( fp_out != stdout ){
		fclose( fp_out );
	}

	return;
}
/*--------------------------------------------------------------------*/
/* ̃ftHglZbg */
void initinit( ){

	/* PMDRCC^[tF[Xݒ */
	t_opif.i_iv = si_IFVersion;
	t_opif.i_av = si_APVersion;
	t_opif.i_at = DO_APTYPE_UK;
	t_opif.i_mmllevel = DN_OL_NORMAL;
	t_opif.i_dumpmode = DN_DL_NODUMP;
	t_opif.i_voicemode = DA_ON;
	t_opif.i_definemode = DA_ALL;
	t_opif.i_zenlen = 96;
	t_opif.i_lendef = t_opif.i_zenlen / 8;
	t_opif.i_lenmin = t_opif.i_lendef / 2;
	t_opif.i_len3min = (t_opif.i_lenmin/3)*4;
	t_opif.i_barlevel = DA_AUTO;
	t_opif.i_manoffset = 0;
	t_opif.i_directmes = DA_ON;
	t_opif.cp_indata = NULL;
	t_opif.i_autolendef = DA_ON;

	/* F2PCVC^[tF[Xݒ */
	t_f2pif.i_iv = si_f2pIFVersion;
	t_f2pif.i_directmes = DA_ON;
	t_f2pif.i_datatype = 0;
	t_f2pif.cp_indata = NULL;
	t_f2pif.cp_debugdata = NULL;

	return;
}
/*--------------------------------------------------------------------*/
/*  */
/* ̓C ԋplFt@C */
/* ŏɓoꂷA'/'or'-'ȊOŎn܂t@CƔFŐ؂ */
char *anarg( int argc , char **argv ){

	int i_argcnt;
	char *cp_curarg;

	/* ȌiftHl̃Zbgj */
	initinit( );

	if( argc < 2 ){
		/* Ȃ */
		return(NULL);
	}

	for(i_argcnt=1;i_argcnt<argc;i_argcnt++){
		cp_curarg = argv[i_argcnt];
		if( *cp_curarg == (char)'-' || *cp_curarg == (char)'/' ){
			/* R}hC */
			setargvalue( cp_curarg+1 );
		}else{
			/* t@C */
			return( cp_curarg );
		}
	}

	return(NULL);
}
/*--------------------------------------------------------------------*/
/*  */
/* _CAO[h */
void startdialog( ){

	char cs_input[256];
	char *cp_ret;
	int i_value;

	fprintf(stderr,"       Z(zenlen           now=%3d) :",t_opif.i_zenlen);
	cp_ret = gets( cs_input );
	if( strlen(cp_ret) != 0 ){
		i_value = atoi( cs_input );
		switch( i_value ){
			case 48:
			case 96:
			case 192:
				t_opif.i_zenlen = i_value;
				/* ftHglR}h̒lAzenlenɊւȂ16ɂ */
				t_opif.i_lendef = t_opif.i_zenlen / 16;
				break;
			default:
				fprintf( stderr , "E[JPR] Wrong length %d, you can specifies 48, 96, and 192.\n", i_value );
				exit(0);
				break;
		}
	}
	fprintf(stderr,"       l(default length / now=%3d) :",
		t_opif.i_zenlen/t_opif.i_lendef);
	cp_ret = gets( cs_input );
	if( strlen(cp_ret) != 0 ){
		i_value = atoi( cs_input );
		if( t_opif.i_zenlen%i_value == 0 ){
			t_opif.i_lendef = t_opif.i_zenlen/i_value;
		}else{
			fprintf( stderr , "E[JPR] %d cannot divide %d.\n",
				t_opif.i_zenlen , i_value );
			exit(0);
		}
	}
	fprintf(stderr,"       b(minimum length / now=%3d) :",
		t_opif.i_zenlen/t_opif.i_lenmin);
	cp_ret = gets( cs_input );
	if( strlen(cp_ret) != 0 ){
		i_value = atoi( cs_input );
		if( t_opif.i_zenlen%i_value == 0 ){
			if( t_opif.i_zenlen/i_value <= t_opif.i_lendef ){
				t_opif.i_lenmin = t_opif.i_zenlen/i_value;
			}else{
				fprintf( stderr , "E[JPR] Too big so.\n");
				exit(0);
			}
		}else{
			fprintf( stderr , "E[JPR] %d cannot divide %d.\n",
				t_opif.i_zenlen , i_value );
			exit(0);
		}
	}

	return;
}
/*--------------------------------------------------------------------*/
/*  */
/* ͏ڍ */
void setargvalue( char *cp_in ){

	int i_value;

	switch( *cp_in ){
		case 'Z':
			/* #Zenlen default=192 */
			i_value = atoi( cp_in+1 );
			switch( i_value ){
				/* `N`Ȓl͋p */
				case 48:
				case 96:
				case 192:
				case 64:
				case 128:
				case 84:
				case 168:
				/* ƂĂȂ14/8q΍() */
					t_opif.i_zenlen = i_value;
					/* ftHglR}h̒lAzenlenɊւȂ16ɂ */
					t_opif.i_lendef = t_opif.i_zenlen / 16;
					return;
			}
			break;
		case 'l':
			/* lR}h(Öى) w default=16(%12) */
			i_value = atoi( cp_in+1 );
			if( i_value == 0 ){
				/* [w肳ꂽꍇ͕WgpȂ (1.00c) */
				fprintf( stderr , " [JPR] Forbidden use l command.\n" );
				t_opif.i_lendef = 0;
				return;
			}else if( t_opif.i_zenlen%i_value == 0 ){
				t_opif.i_lendef = t_opif.i_zenlen/i_value;
				return;
			}
			break;
		case 'b':
			/* Ŏŏ w default=32(%6) */
			i_value = atoi( cp_in+1 );
			if( t_opif.i_zenlen%i_value == 0 ){
				t_opif.i_lenmin = t_opif.i_zenlen/i_value;
				t_opif.i_len3min = (t_opif.i_lenmin/3)*2;
				return;
			}
			break;
		case 'B':
			/* ߐ̋N_ def/0:auto 1:[L] 2:top */
			t_opif.i_autothresh = atoi( cp_in+1 );
			fprintf( stderr , " [JPR] Bar-line origin is top of data.\n" );
			return;
		case 'F':
			/* ߐ̋N_ItZbg */
			t_opif.i_manoffset = atoi( cp_in+1 );
			if( t_opif.i_manoffset > t_opif.i_zenlen ){
				/* ߒ蒷ꍇA]Ƃ */
				t_opif.i_manoffset = t_opif.i_manoffset % t_opif.i_zenlen;
			}
			fprintf( stderr , " [JPR] Bar-line offset is [%d].\n" ,
				t_opif.i_manoffset);
			return;
		case '@':
			/* elof[^ǂݍݎ̃e|olcf[^ */
			/* t@Cɏo͂ꍇ */
			t_f2pif.cp_debugdata = (cp_in+1);
			return;
		case '.':
			/* o͂llkt@Cw */
			gcp_outfilename = (cp_in+1);
			return;
		case 'L':
			/* o̓x */
			i_value = atoi( cp_in+1 );
			if( i_value >= 2  && i_value <= 5 ){
				t_opif.i_mmllevel = i_value;
				fprintf( stderr , " [JPR] OUTPUT-Level is %d.\n" , i_value );
				if( i_value >= 4 ){
					/* Level4̂Ƃ'@'Ȃ̂ŉF`sv */
					t_opif.i_voicemode = DA_OFF;
					/* Level4̂Ƃdefinep[ĝ݂ */
					t_opif.i_definemode = DA_DEFL_PARTEXTEND;
				}
				return;
			}else{
				fprintf( stderr , "E[JPR] OUTPUT-Level is %d." , i_value );
				exit(1);
			}
			break;
		case 'n':
			/* "no******" ̈c */
			if( 0 ==
				strncmp(cp_in,"nobarline",strlen("nobarline")) ){
				t_opif.i_barlevel = DA_OFF;
				fprintf( stderr , " [JPR] Forbidden insert disregard-bar.\n" );
				return;
			}
			if( 0 ==
				strncmp(cp_in,"noautolen",strlen("noautolen")) ){
				t_opif.i_autolendef = DA_OFF;
				fprintf( stderr , " [JPR] Forbidden automatic l command.\n" );
				return;
			}
			if( 0 ==
				strncmp(cp_in,"novdump",strlen("novdump")) ){
				t_opif.i_voicemode = DA_OFF;
				fprintf( stderr , " [JPR] Voice-mode is DISABLE.\n" );
				return;
			}
			break;
		case 'd':
			/* "do******" ̈c */
			if( 0 ==
				strncmp(cp_in,"dobarline",strlen("dobarline")) ){
				t_opif.i_barlevel = DA_FORCED;
				fprintf( stderr , " [JPR] Compulsion insert disregard-bar.\n" );
				return;
			}
			if( 0 ==
				strncmp(cp_in,"dodump",strlen("dodump")) ){
				t_opif.i_dumpmode = DN_DL_FRAMEDUMP;
				t_opif.i_mmllevel = 5;
				fprintf( stderr , " [JPR] Running-mode is TRACKDUMP.\n" );
				return;
			}
			if( 0 ==
				strncmp(cp_in,"dosdump",strlen("dosdump")) ){
				t_opif.i_dumpmode = DN_DL_SUPERDUMP;
				t_opif.i_mmllevel = 5;
				fprintf( stderr , " [JPR] Running-mode is SUPERTRACKDUMP.\n" );
				return;
			}
			if( 0 ==
				strncmp(cp_in,"dodebug",strlen("dodebug")) ){
				t_opif.i_dumpmode = DN_DL_SUPERDUMP;
				t_opif.i_mmllevel = 5;
				t_opif.i_directmes = t_opif.i_directmes | DA_DEBUG;
				fprintf( stderr , " [JPR] Running-mode is DEBUGMODE.\n" );
				return;
			}
			if( 0 ==
				strncmp(cp_in,"dodialog",strlen("dodialog")) ){
				gi_dodialog = DA_ON;
				fprintf( stderr , " [JPR] Running-mode is DIALOG.\n" );
				return;
			}
			if( 0 ==
				strncmp(cp_in,"dotx81z",strlen("dotx81z")) ){
				t_opif.i_voicemode = DA_TX81ZVOICE;
				fprintf( stderr , " [JPR] Voice-mode is \"TX81Z\".\n" );
				return;
			}
	/* V1.21 2008/7/14 start */
			if( 0 ==
				strncmp(cp_in,"doautotrans",strlen("doautotrans")) ){
				t_opif.c_autotrans = D_ON;
				fprintf( stderr , " [JPR] enable, auto-Transpose mode.\n" );
				return;
			}
			break;
	/* V1.21 2008/7/14 end */
		default:
			/* mȂ */
			fprintf( stderr , "W[JPR] Arg. unknown. [/%s]\n\n" , cp_in );
			return;
	}


	fprintf( stderr , "E[JPR] Arg. invalid value. [/%s]\n\n" , cp_in );

	exit(1);
}
